' ########################################################################################
' Reads the contents of an Excel BIFF file and outputs it to a text file.
' ########################################################################################
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "propidl.inc"
#INCLUDE ONCE "OLE2UTILS.inc"
TYPE tIdentifier
    idNumber AS WORD
    szSize AS WORD
END TYPE
TYPE tFormat
    ifmt AS WORD       'Format index code (for internal use only)
    'What follows is a BiffString with a 2 byte cch length
END TYPE

FUNCTION PBMAIN
    DIM hr AS LONG
    DIM pStorage AS IStorage
    DIM pStream AS IStream
    DIM wszName AS STRING
    'Movement variables
    DIM qNewPos AS QUAD
    DIM cbRead AS DWORD
    DIM cbSize AS QUAD
    DIM seekDistance AS QUAD
    'Excel file UDTs
    DIM Identifier AS tIdentifier
    'Stored Excel File Info
    DIM BiffVersion AS BYTE
    DIM numberFormats() AS STRING
    DIM curNumFmt AS LONG
    'Immediate tmp variables
    DIM s AS STRING
    DIM i AS LONG
    'Timer variable
    DIM start AS DOUBLE
    DIM ghettoDebugAssert AS QUAD

    start = TIMER
    wszName = UCODE$("Test.xls")
    hr = StgOpenStorage(STRPTR(wszName), NOTHING, _
        %STGM_DIRECT_SWMR OR %STGM_READWRITE OR %STGM_SHARE_EXCLUSIVE, _
        0, %NULL, pStorage)
    IF FAILED(hr) THEN
      MSGBOX "StgOpenStorage failure: " & HEX$(hr)
      EXIT FUNCTION
    END IF
    wszName = UCODE$("Workbook")
    hr = pStorage.OpenStream(STRPTR(wszName), 0, %STGM_READWRITE OR %STGM_SHARE_EXCLUSIVE, 0, pStream)
    IF FAILED(hr) THEN
        wszName = UCODE$("Book")
        hr = pStorage.OpenStream(STRPTR(wszName), 0, %STGM_READWRITE OR %STGM_SHARE_EXCLUSIVE, 0, pStream)
        IF FAILED(hr) THEN
            MSGBOX "IStorage.OpenStream failure: " & HEX$(hr)
            EXIT FUNCTION
        END IF
    END IF

    cbSize = IStream_GetSize(pStream)

    DO UNTIL qNewPos + 1 > cbSize
        hr = pStream.Seek(0, %STREAM_SEEK_CUR, qNewPos)
        IF qNewPos  = &H8B0 OR qNewPos  = &H8CE THEN
             ghettoDebugAssert = ghettoDebugAssert
        END IF
        'Read the current identifier
        hr = pStream.Read(VARPTR(Identifier), SIZEOF(Identifier), cbRead)
        hr = pStream.Seek(0, %STREAM_SEEK_CUR, qNewPos)
        IF LO(BYTE, Identifier.idNumber) = &H09 THEN                                    'BOF marker
            BiffVersion = HI(BYTE, Identifier.idNumber)
            'If needed you would read either tBOF57 or tBOF8 here depending on BiffVersion.
            'We are defaulting to the seek in the below if statement for this example.
        END IF
        IF Identifier.idNumber = &H1E  OR Identifier.idNumber = &H41E THEN              'Number Format
            INCR curNumFmt
            'Ghetto vector
            IF curNumFmt > UBOUND(numberFormats) THEN
                REDIM PRESERVE numberFormats(UBOUND(numberFormats) + 20) AS STRING
            END IF
            seekDistance = SIZEOF(tFormat)
            hr = pStream.Seek(seekDistance, %STREAM_SEEK_CUR, qNewPos)
            numberFormats(curNumFmt) = ReadBiffString(2, BiffVersion, pStream) & " " & HEX$(qNewPos)
            hr = pStream.Seek(0, %STREAM_SEEK_CUR, qNewPos)
        ELSE
            seekDistance = Identifier.szSize
            hr = pStream.Seek(seekDistance, %STREAM_SEEK_CUR, qNewPos)
        END IF
    LOOP
    pStream = NOTHING
    pStorage = NOTHING
    MSGBOX "Total runtime: " & FORMAT$(TIMER - start, "#,##0.00")
END FUNCTION


''Tested and appears to be working as expected. SizeOfCch should be 2 except in the case of worksheet
''names when it is 1. Refer to the BIFF docs.
FUNCTION ReadBiffString(BYVAL SizeOfCch AS DWORD, BiffVersion AS BYTE, pStream AS IStream) AS STRING
    DIM hr AS LONG
    DIM cbRead AS DWORD
    DIM qNewPos AS QUAD
    DIM cc1 AS BYTE
    DIM cch AS WORD         'Count of characters in the string (Note: this is the number of chars, NOT bytes)
    DIM grbit AS BYTE       'Option flags (only used in BIFF8)
    DIM sRgb AS STRING      'Array of string characters and formatting runs
    DIM fHighByte AS BYTE   '=0 if all the characters in the string have a high byte of 00h
                            'and only the low bytes are saved in the file (compressed)
                            '=1 if at least one character in the string has a nonzero high byte and therefore
                            'all characters in the string are saved as double-byte characters (not compressed)
    DIM fExtSt AS BYTE      'Extended string flag
    DIM fRichSt AS BYTE     'Rich string flag
    DIM cchExtRst AS DWORD  'Length of ExtRst data
    DIM numRuns AS WORD     'The number of formatting runs in the BiffString
    'dim runs() as tRun     'The formatting runs.. not implemented in this function
    'dim i as word
    IF SizeOfCch = 1 THEN
        hr = pStream.Read(VARPTR(cc1), SIZEOF(cc1), cbRead)
        cch = cc1
    ELSE
        hr = pStream.Read(VARPTR(cch), SIZEOF(cch), cbRead)
    END IF
    IF BiffVersion < &H08 THEN
        FUNCTION = IStream_ReadText(pStream, CLNG(cch))
    ELSE
        hr = pStream.Read(VARPTR(grbit), SIZEOF(grbit), cbRead)
        SELECT CASE grbit
            CASE &H00 'the BiffString is compressed unicode
                FUNCTION = IStream_ReadText(pStream, CLNG(cch))
            CASE &H01 'the BiffString is Unicode
                FUNCTION = IStream_ReadText(pStream, CLNG(cch * 2))
            CASE ELSE
                fHighByte = BIT(grbit, 0)
                fExtSt    = BIT(grbit, 2)
                fRichSt   = BIT(grbit, 3)
                IF fExtSt = 0 THEN
                    'The BiffString is a rich string that contains a series of runs
                    hr = pStream.Read(VARPTR(numRuns), SIZEOF(numRuns), cbRead)
                    'redim runs(numRuns) as tRun
                    IF fHighByte = 0 THEN
                        'the BiffString is compressed unicode
                        FUNCTION = IStream_ReadText(pStream, CLNG(cch))
                    ELSE
                        'the BiffString is Unicode
                        FUNCTION = IStream_ReadText(pStream, CLNG(cch * 2))
                    END IF
                    'Read in all of the run data
                    'for i = 0 to numRuns - 1
                    '   hr = pStream.Read(varptr(runs(i)), sizeof(runs(i)), cbRead)
                    'NEXT
                    'Since we are not processing the formatting code, just bypass it
                    hr = pStream.Seek(CQUD(numRuns * 4), %STREAM_SEEK_CUR, qNewPos)
                ELSE
                    'The BiffString is an Extended String which contains some undocumented features
                    IF fRichSt = 1 THEN
                        'The BiffString does contain formatting runs
                        hr = pStream.Read(VARPTR(numRuns), SIZEOF(numRuns), cbRead)
                        'redim runs(numRuns) as tRun
                    END IF
                    hr = pStream.Read(VARPTR(cchExtRst), SIZEOF(cchExtRst), cbRead)
                    IF fHighByte = 0 THEN
                        'the BiffString is compressed unicode
                        FUNCTION = IStream_ReadText(pStream, CLNG(cch))
                    ELSE
                        'the BiffString is Unicode
                        FUNCTION = IStream_ReadText(pStream, CLNG(cch * 2))
                    END IF
                    IF fRichSt = 1 THEN
                        'Read in all of the run data
                        'for i = 0 to numRuns - 1
                        '   hr = pStream.Read(varptr(runs(i)), sizeof(runs(i)), cbRead)
                        'NEXT
                        'Since we are not processing the formatting code, just bypass it
                        hr = pStream.Seek(CQUD(numRuns * 4), %STREAM_SEEK_CUR, qNewPos)
                    END IF
                    'Bypass undocumented ExtRst data
                    hr = pStream.Seek(CQUD(cchExtRst), %STREAM_SEEK_CUR, qNewPos)
                END IF
        END SELECT
    END IF
END FUNCTION
